



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Asp.net MVC Razor模板引擎技巧分享</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Asp.net MVC Razor模板引擎技巧分享</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 13:25:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Razor是Asp.net MVC中新的默认模板类型, 语法简单易用。这篇文章不涉及Razor的语法，主要介绍Razor的一些在MVC项目中的使用技巧，以及脱离MVC环境下，如何使用Razor.</p>
<blockquote><p>阅读目录:</p>
<p>一、Razor和MVC关系</p>
<p>二、MVC中扩展Razor寻找模板范围</p>
<p>三、MVC中使用Razor生成Html片段</p>
<p>四、脱离MVC, 使用Razor独立作为模板引擎</p>
<p>五、其它</p></blockquote>
<h1>1. Razor和MVC关系</h1>
<p>Razor是MVC中的默认模板引擎，MVC中还有ASPX模板引擎，在早期的MVC版本中，默认使用的是ASPX模板引擎。<br />当默认添加一个View文件的时候，可以看到MVC默认带的2个模板引擎。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/14408/201402/120825170971571.png" /></p>
<p>你还可以引入其它的模板引擎到MVC项目中来, MVCContrib项目是一个对MVC进行扩展的项目, 项目的地址是:<a href="http://mvccontrib.codeplex.com" rel="external nofollow noreferrer">http://mvccontrib.codeplex.com</a>这里有它提供的一份MVC中可以扩展的模板引擎列表。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/14408/201402/120825176118656.png" /></p>
<p>总之，这里想说的是，<strong>模板引擎是独立的</strong>，它们甚至是独立的项目，由不同的公司和组织来开发。你可以在MVC中使用你熟悉的模板引擎。<br />下面主要是关于Razor在MVC中的一些使用技巧。</p>
<h1>2. MVC中扩展Razor寻找模板范围</h1>
<p>看下面这个Controller中的Action方法:</p>
<div>
<pre class="prettyprint linenums">public class TestController : Controller<br />
{<br />
     public ActionResult Index()<br />
     {<br />
         return View();<br />
     }<br />
}</pre>
</div>
<p>这是一个简单的Action方法Index,&nbsp; 其中的return View()方法会将流程转向View Engine来处理。如果我们没有创建一个View\Test\Index.cshtml文件，则会出现下面的错误页面:</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/14408/201402/120825183757056.png" /></p>
<p>从上面很容易看出来，MVC默认支持的view类型, aspx, ascx, cshtml和vbhtml.<br />以及<strong>找寻对应View的路径规则</strong>是:</p>
<p>~View/{Controller}/{Action}<br />~View/Shared/{Action}</p>
<p>然而<strong>在现实开发中，使用默认的查找View路径，就完全限定住了View的层级结构，不适合复杂项目的开发</strong>。</p>
<p>比如在Shared共享的View文件夹中，希望再细分为Partial, Common, Email, EditorTemplate等<br />比如在每个Controller对应的文件夹中，你希望在添加一个文件夹为Partial，用来存放那些呈现页面某个部分的view文件。</p>
<p>你只需要在Global.asax.cs文件中的Application_Start方法中，添加几行代码就可以了。</p>
<div>
<pre class="prettyprint linenums">protected void Application_Start()<br />
{<br />
    &hellip;&hellip;&hellip;&hellip;&hellip;&hellip;.<br />
    ViewEngines.Engines.Add(<br />
    new RazorViewEngine<br />
        {<br />
            PartialViewLocationFormats = new[]<br />
                  {<br />
                        "~/Views/{1}/Partial/{0}.cshtml",<br />
                        "~/Views/Shared/Partial/{0}.cshtml",<br />
                        "~/Views/Shared/Common/{0}.cshtml",<br />
                        "~/Views/Shared/Email/{0}.cshtml",<br />
                        "~/Views/Shared/EditorTemplate/{0}.cshtml"<br />
                  }<br />
      });<br />
 }</pre>
</div>
<p>上面中的{1}是Controller， {0}对应的是Action.</p>
<p>看看下面这张图, 可以看出来，还有很多其它的扩展点，Area， FileExtensions等，大家可以试试看。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/14408/201402/120825192197713.png" /></p>
<h1>3. MVC中使用Razor生成Html字符串</h1>
<p>项目中常常会用到Ajax局部刷新页面的情况，如果只是刷新一个局部区域，还比较简单，可以使用一个对应的Action来响应Ajax请求，获取刷新的html内容，但是如果是需要刷新页面中的多个区域的时候，怎么办呢? 这个时候，我们希望后台返回的结果是一个类似这样的Json格式.</p>
<div>
<pre class="prettyprint linenums">return Json(new<br />
           {<br />
               Success = true,<br />
               Message = "Sucess",<br />
               HtmlPart1 = &hellip;&hellip;..<br />
               HtmlPart2 = &hellip;&hellip;.<br />
           }, JsonRequestBehavior.AllowGet);</pre>
</div>
<p>要解决这个问题，可以非常方便的使用下面的Controller扩展方法解决:</p>
<div>
<pre class="prettyprint linenums">public static class ControllerExtension<br />
{<br />
      /// &lt;summary&gt;<br />
      /// Renders a (partial) view to string.<br />
      /// &lt;/summary&gt;<br />
      /// &lt;param name="controller"&gt;Controller to extend&lt;/param&gt;<br />
      /// &lt;param name="viewName"&gt;(Partial) view to render&lt;/param&gt;<br />
      /// &lt;returns&gt;Rendered (partial) view as string&lt;/returns&gt;<br />
      public static string RenderPartialViewToString(this ControllerBase controller, string viewName)<br />
      {<br />
          return controller.RenderPartialViewToString(viewName, null);<br />
      }

      /// &lt;summary&gt;<br />
      /// Renders a (partial) view to string.<br />
      /// &lt;/summary&gt;<br />
      /// &lt;param name="controller"&gt;Controller to extend&lt;/param&gt;<br />
      /// &lt;param name="viewName"&gt;(Partial) view to render&lt;/param&gt;<br />
      /// &lt;param name="model"&gt;Model&lt;/param&gt;<br />
      /// &lt;returns&gt;Rendered (partial) view as string&lt;/returns&gt;<br />
      public static string RenderPartialViewToString(this ControllerBase controller, string viewName, object model)<br />
      {<br />
          if (string.IsNullOrEmpty(viewName))<br />
              viewName = controller.ControllerContext.RouteData.GetRequiredString("action");

          controller.ViewData.Model = model;

          using (var sw = new StringWriter())<br />
          {<br />
              var viewResult = ViewEngines.Engines.FindPartialView(controller.ControllerContext, viewName);<br />
              var viewContext = new ViewContext(controller.ControllerContext, viewResult.View, controller.ViewData, controller.TempData, sw);<br />
              viewResult.View.Render(viewContext, sw);

              return sw.GetStringBuilder().ToString();<br />
          }<br />
      }<br />
}</pre>
</div>
<p>那么上面的返回结果，就可以改成:</p>
<div>
<pre class="prettyprint linenums">return Json(new<br />
           {<br />
               Success = true,<br />
               Message = "Sucess",<br />
               HtmlPart1 = this.RenderPartialViewToString("_HtmlPart1", model1),<br />
               HtmlPart2 = this.RenderPartialViewToString("_HtmlPart2", model2),

           }, JsonRequestBehavior.AllowGet);</pre>
</div>
<h1>4. 脱离MVC, 使用Razor独立作为模板引擎</h1>
<p><strong>RazorEngine</strong>是一个独立的开源项目，项目的地址是<a href="https://github.com/Antaris/RazorEngine" rel="external nofollow noreferrer">https://github.com/Antaris/RazorEngine</a>它是基于微软的Razor之上，包装而成的一个可以独立使用的模板引擎。也就是说，保留了Razor的模板功能，但是使得Razor脱离于Asp.net MVC，能够在其它应用环境下使用。我现在一般这个来生成Email文本，当然也有人用来做代码生成器。</p>
<p>使用也非常简单:</p>
<div>
<pre class="prettyprint linenums">string template = "Hello @Model.Name! Welcome to Razor!";<br />
string result = Razor.Parse(template, new { Name = "World" });</pre>
</div>
<p>上面result的结果就是 &ldquo;Hello World! Welcome to Razor!&rdquo;</p>
<h1>5. 其它</h1>
<p>这篇文章主要是在Razor实际使用过程中，一些学到到知识，拿来这里分享. 没有涉及Razor的语法这些内容，大家可以自行搜索，网上有很多介绍的文章。</p>
<p>关于<strong>代码生成器的一些个人看法</strong>，以前在看到代码生成器的时候，觉得是个好东西，非常牛，能够减少不少工作量。后来在深入的学习之后，发现必要性不是很大，如果程序中的代码很多是需要生成的，那么可能大部分都是重复和相似的代码，这些代码应该是可以通过设计模式来重构精简的。</p>
<p>避免使用代码生成器，不止能够精简代码，还能为你打开另外一道门，大家不妨试试。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495xvvv8.html">关于label的点击事件&lpar;原创&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldxpx9.html">Liferay 6&period;2 改造系列之十一：默认关闭CDN动态资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/r935lyrq.html">&lbrack;转&rsqb;Java 内部类笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vor2j8.html">ER 和 数据库关系模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljzozx9.html">&lbrack;Codeforces Round &num;438&rsqb;&lbrack;Codeforces 868C&period; Qualification Rounds&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o14lg5q.html">python &plus; MySql 基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy4w0jq.html">【CF1141F1】Same Sum Blocks</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2jv1j9.html">Kayleigh O&amp;&num;39&semi;Connor - I Won&amp;&num;39&semi;t Be There</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvgjkk8.html">js的Timer方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw76xy8.html">NumPy 基础用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj0m379.html">逆元&amp;amp&semi;欧拉函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdjzge9.html">面向对象数据库（Object Oriented Databases）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4vdwx9.html">通过 DDNS 解决宽带拨号 ip 变化问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyykepjq.html">在Ubuntu上使用noip动态域名的方法&lpar;ddns&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4p5xx9.html">spring 通过&commat;Value 获取properties文件中设置了属性 ，与&commat;Value  &num; 和&dollar;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g5wmmq.html">Eclipse和Myeclipse的Properties插件（解决properties文件乱码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjje2xq.html">显示eclipse中Problem窗口的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e7ome9.html">ios开发之--通过通知监听textfield的输入状态，判断按钮的状态</a>
		</li>
						<li><a href="https://www.batexi.com/a/902pgkjq.html">Spring的2&period;5版本中提供了一种&colon;p名称空间的注入（了解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7edd5k9.html">vue-router页面传值及接收值</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q70jwk8.html">iOS阶段学习第六天笔记（数组）</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93g65w8.html">利用Abot爬虫和visjs 呈现漫威宇宙</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rkmldq.html">SSH实例&lpar;4&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8olrj58.html">&lbrack;python拾遗&rsqb;文件操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv3w1x8.html">Verilog学习笔记认识提升篇（一）&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;&period;时序的基本概念（待补充）</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn4z7g8.html">SSH免密码登录过程解析和实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8krgw7q.html">prototype和&lowbar;&lowbar;proto&lowbar;&lowbar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1w7m49.html">一种基于annotation的Spring-mvc权限控制方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8krem3q.html">&commat;media自适应宽度</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jd30g9.html">bootstrap源码分析之tab（选项卡）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
